uniform sampler2D texture;
varying vec4 outColor;
varying vec4 outTexCoord;

const vec4 lumcoeff = vec4(0.299, 0.587, 0.114, 0);

void main() {
  vec4 color = texture2D(texture, outTexCoord.st);

  // float luminance = lumcoeff.x * color.x + lumcoeff.y * color.y +
  //                   lumcoeff.z * color.z;
  float luminance = dot(color, lumcoeff);

  if (luminance < 0.5) {
    gl_FragColor = vec4(0, 0, 0, 1);
  } else {
  	gl_FragColor = vec4(1);
  }
}