uniform sampler2D texture;
uniform float umbral;

varying vec4 vertTexCoord;

const vec4 lumcoeff = vec4(0.299, 0.587, 0.114, 0);

void main() {
  vec4 color = texture2D(texture, vertTexCoord.st);
  float luminance = dot(color, lumcoeff);

  if (luminance < umbral) {
    gl_FragColor = vec4(0, 0, 0, 1);
  } else {
  	gl_FragColor = vec4(1);
  }
}