PShape octa;
PShader subdiv;
float angle;
boolean useSubdiv = true;

void settings() {
  size(400, 400, P3D);
  PJOGL.profile = 3;
}

void setup() {
  octa = createOctahedron();

  subdiv = loadGeometryShader("vert.glsl", "geom.glsl", "frag.glsl");
  shader(subdiv);
}

void draw() {
  background(0);  

  pointLight(204, 204, 204, 0, 0, 200);

  translate(width/2, height/2, 0);
  
  scale(100);
  angle += 0.01;
  rotateY(angle);  
  shape(octa);
  if (useSubdiv) {
    shape(octa);
    shader(subdiv);
  }
}

void keyPressed() {
  useSubdiv = !useSubdiv;
  if (useSubdiv) shader(subdiv);
  else resetShader();
}

void mouseMoved() {
  subdiv.set("level", int(map(mouseX, 0, width, 0, 4)));
}  