import java.nio.*;

float[] attribs;
FloatBuffer attribBuffer;
int vboId;

void setup() {
  size(360, 360, P3D);
  
  setGeometry(); 
  createVBO();
}

void draw() {
  
}

void setGeometry() {
  // 24 = 3 * 4 * 2 = numero de vertices * comp por vertice
  attribs = new float[24];
  attribBuffer = ByteBuffer.allocateDirect(24 * Float.BYTES).order(ByteOrder.nativeOrder()).asFloatBuffer();
  
  // Position 1
  attribs[0] = 0;
  attribs[1] = 0;
  attribs[2] = 0;
  attribs[3] = 1;

  // Color 1
  attribs[4] = 1;
  attribs[5] = 0;
  attribs[6] = 0;
  attribs[7] = 1;

  // Vertex 2
  attribs[8] = width/2;
  attribs[9] = height;
  attribs[10] = 0;
  attribs[11] = 1;

  // Color 2
  attribs[12] = 0;
  attribs[13] = 1;
  attribs[14] = 0;
  attribs[15] = 1;

  // Vertex 3
  attribs[16] = width;
  attribs[17] = 0;
  attribs[18] = 0;
  attribs[19] = 1;

  // Color 3
  attribs[20] = 0;
  attribs[21] = 0;
  attribs[22] = 1;
  attribs[23] = 1;

  attribBuffer.rewind();
  attribBuffer.put(attribs);
  attribBuffer.rewind();
}

void createVBO() {
  PGL pgl = beginPGL();
  IntBuffer intBuffer = IntBuffer.allocate(1);
  pgl.genBuffers(1, intBuffer);
  vboId = intBuffer.get(0);
  
  pgl.bindBuffer(PGL.ARRAY_BUFFER, vboId);
  pgl.bufferData(PGL.ARRAY_BUFFER, 24 * Float.BYTES, attribBuffer, PGL.STATIC_DRAW);                    
  pgl.bindBuffer(PGL.ARRAY_BUFFER, 0);
  
  endPGL();
}