import java.nio.*;

float[] attribs;
FloatBuffer attribBuffer;
int vboId;

PShader sh;

void setup() {
  size(360, 360, P3D);

  sh = loadShader("frag.glsl", "vert.glsl");
  
  setGeometry(); 
  createVBO();
}

void draw() {
  PGL pgl = beginPGL();
  
  background(0);
  
  rotateY(frameCount * 0.01);
    
  sh.bind();
  
  int posLoc = pgl.getAttribLocation(sh.glProgram, "position");
  pgl.enableVertexAttribArray(posLoc);
  
  int colorLoc = pgl.getAttribLocation(sh.glProgram, "color");
  pgl.enableVertexAttribArray(colorLoc);
    
  pgl.bindBuffer(PGL.ARRAY_BUFFER, vboId);
                      
  //  |v1       |v2       |v3       |...
  //  |0   |4   |8   |12  |16  |20  |...
  //  |xyzw|rgba|xyzw|rgba|xyzw|rgba|...
  int size = 4;
  int stride = (4 + 4) * Float.BYTES;
  int offset = 4 * Float.BYTES;
  pgl.vertexAttribPointer(posLoc, size, PGL.FLOAT, false, stride, 0);
  pgl.vertexAttribPointer(colorLoc, size, PGL.FLOAT, false, stride, offset);
  
  pgl.drawArrays(PGL.TRIANGLES, 0, 3);
  
  pgl.bindBuffer(PGL.ARRAY_BUFFER, 0);
  
  pgl.disableVertexAttribArray(posLoc);  
  pgl.disableVertexAttribArray(colorLoc);
  
  sh.unbind();
  
  endPGL();
}